﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using Newtonsoft.Json;
using Newtonsoft.Json.Serialization;
using System.Reflection;

namespace HeuristicLab.Clients.Hive.WebJobManager.Services
{
    /// <summary>
    /// Throws some properties out to save on bandwidth space while refreshing 
    /// the selected job
    /// </summary>
    public class JsonTaskResolver : DefaultContractResolver
    {
        protected override JsonProperty CreateProperty(MemberInfo member,
                                            MemberSerialization memberSerialization)
        {
            JsonProperty property = base.CreateProperty(member, memberSerialization);
            if (property.PropertyName == "ItemImage" ||
                property.PropertyName == "Parameters" ||
                property.PropertyName == "OperatorGraph" ||
                property.PropertyName == "DistanceMatrix" ||
                property.PropertyName == "Operators" ||
                property.PropertyName == "Engine" ||
                property.PropertyName == "ActualValue" ||
                property.PropertyName == "CurrentScope" ||
                property.PropertyName == "Problems" ||
                property.PropertyName == "Random" ||
                property.PropertyName == "Optimizer" ||
                property.PropertyName == "Optimizers" ||
                property.PropertyName == "Problem" ||
                property.PropertyName == "NestedOptimizers")
            {
                property.ShouldSerialize = instanceOfProblematic => false;
            }

            return property;
        }
    }

}
